clear adat
close all

adatfile=fopen('D:\student\BeagyAmbLaborBSc2010\temp\Meres2_kellek\Lokalizacio\SimpleCollect\motedata\mic.dat');
adat=fscanf(adatfile, '%d, %d, %d\n', [3 inf]);
fclose(adatfile)

%DC komponens eltvoltsa
adat(1,:)=adat(1,:)-mean(adat(1,:));
adat(2,:)=adat(2,:)-mean(adat(2,:));
adat(3,:)=adat(3,:)-mean(adat(3,:));

%Meghvjuk az interpolcis fggvnyt, 20-szoros interpollst vgznk
adat1=interpolate(adat(1,:),20);
adat2=interpolate(adat(2,:),20);
adat3=interpolate(adat(3,:),20);

figure
subplot(3,1,1)
plot(adat1)
subplot(3,1,2)
plot(adat2)
subplot(3,1,3)
plot(adat3)

% Keresztkorrelci szmtsa a chirp jel s a mtok felvtelei kztt
korr_mot_1=xcorr(y,adat1);
korr_mot_2=xcorr(y,adat2);
korr_mot_3=xcorr(y,adat3);

% A korrelcis fggvnyek els cscsrtkeinek meghatrozsa
korr_mot_t1=find(korr_mot_1==max(korr_mot_1),1,'first');
korr_mot_t2=find(korr_mot_2==max(korr_mot_2),1,'first');
korr_mot_t3=find(korr_mot_3==max(korr_mot_3),1,'first');

%brzoljuk a keresztkorrelcis fggvnyt s kk kereszttel jelljk az
%azonostott cscsokat
figure('Name','Keresztkorrelcik')
subplot(3,1,1)
plot(korr_mot_1,'r')
hold on
plot(korr_mot_t1,max(korr_mot_1),'xb')
hold off
subplot(3,1,2)
plot(korr_mot_2,'r')
hold on
plot(korr_mot_t2,max(korr_mot_2),'xb')
hold off
subplot(3,1,3)
plot(korr_mot_3,'r')
hold on
plot(korr_mot_t3,max(korr_mot_3),'xb')
hold off

%Kpezzk a megtallt cscsok idklmbsgeit
clc
disp('A megtallt cscsok kztti tvolsgok')
d_12=korr_mot_t1-korr_mot_t2;
d_23=korr_mot_t2-korr_mot_t3;
d_13=korr_mot_t1-korr_mot_t3;
disp(['d_12: ', num2str(d_12),'  d_23: ', num2str(d_23),'  d_13: ', num2str(d_13),])

%A helymeghatrozshoz szksges cellk ltrehozsa
dd{1}=d_12;             %az egyes moteprok esetn az rkezsi id klnbsg
dd{2}=d_13;
dd{3}=d_23;

P{1} = [15,10];          %az 1. mote koordinti[x,y]:  x=0cm    , y=0cm
P{2} = [30,40];          %a  2. mote koordinti[x,y]:  x=40.01cm, y=0.1cm
P{3} = [60,6];          %a  3. mote koordinti[x,y]:  x=41.00cm, y=50cm

%Tvolsgbecsl fggvny meghvsa
dispLocationsHiperb(P,dd)